package com.inca.npbusi.saset.bms_sa_rec;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import java.util.ArrayList;

public class Bms_sa_rec_detail extends CDetailModel {
   public Bms_sa_rec_detail(CFrame var1, CMdeModel var2) {
      super(var1, "销售收款单管理", var2);
      this.getDBColumnDisplayInfo("sasettledtlid").setDbcolumn(false);
      this.getDBColumnDisplayInfo("settype").setDbcolumn(false);
   }

   public String getTablename() {
      return "bms_sa_rec_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3;
      if ((var3 = this.getItemValue(var1, "goodsid")) != null && !var3.equals("")) {
         var3 = this.getItemValue(var1, "settype");
         if (!"2".equals(var3)) {
            label37: {
               if ((var3 = this.getItemValue(var1, "goodsqty")) != null && !"".equals(var3)) {
                  if ((var3 = this.getItemValue(var1, "unitprice")) != null && !"".equals(var3)) {
                     break label37;
                  }

                  this.warnMessage("数据项必须输入", "数据项'单价'必须输入");
                  return -1;
               }

               this.warnMessage("数据项必须输入", "数据项'基本单位数量'必须输入");
               return -1;
            }
         }

         if ((var3 = this.getItemValue(var1, "total_line")) != null && !var3.equals("")) {
            return super.on_checkrow(var1, var2);
         } else {
            this.warnMessage("数据项必须输入", "数据项'金额'不能为空");
            return -1;
         }
      } else {
         this.errorMessage("错误", "货品ID不能为空!");
         return -1;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      if (var2.equals("goodsqty")) {
         String var4 = this.getItemValue(var1, "unitprice");
         var4 = DecimalHelper.multi(var3, var4, 2);
         this.setItemValue(var1, "total_line", var4);
         int var5 = this.mdemodel.getMasterModel().getRow();
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).setItemValue(var5, "premoney", this.getDBtableModel().sum("total_line").toString());
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).on_itemvaluechange(var5, "premoney", this.getDBtableModel().sum("total_line").toString());
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   public void gensarecdtl(CTable var1) {
      DBTableModel var2 = (DBTableModel)var1.getModel();
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "recmethod");
      Userruninfo var4 = ClientUserManager.getCurrentUser();
      DBTableModel var5 = this.getDBtableModel();
      int var9 = var1.getRowCount() - 1;
      ArrayList var6 = new ArrayList();

      for(int var7 = 0; var7 < var9; ++var7) {
         String var8;
         if ((var8 = var2.getItemValue(var7, "selectflag")) != null && "1".equals(var8)) {
            var6.add("" + var7);
         }
      }

      int[] var12 = new int[var6.size()];

      int var13;
      for(var13 = 0; var13 < var6.size(); ++var13) {
         var9 = Integer.parseInt((String)var6.get(var13));
         var12[var13] = var9;
      }

      String var10;
      for(var13 = 0; var13 < var12.length; ++var13) {
         if ((var10 = var2.getItemValue(var12[var13], "thistickmoney")) != null && !var10.equals("") && !var10.equals("0") && !var10.equals("0.00")) {
            var9 = var5.getRowCount();
            var5.appendRow();
            var5.setItemValue(var9, "goodsid", var2.getItemValue(var12[var13], "goodsid"));
            var5.setItemValue(var9, "goodsname", var2.getItemValue(var12[var13], "goodsname"));
            var5.setItemValue(var9, "currencyname", var2.getItemValue(var12[var13], "currencyname"));
            var5.setItemValue(var9, "goodstype", var2.getItemValue(var12[var13], "goodstype"));
            var5.setItemValue(var9, "goodsunit", var2.getItemValue(var12[var13], "goodsunit"));
            var5.setItemValue(var9, "prodarea", var2.getItemValue(var12[var13], "prodarea"));
            var5.setItemValue(var9, "factoryname", var2.getItemValue(var12[var13], "factoryname"));
            var5.setItemValue(var9, "goodsqty", var2.getItemValue(var12[var13], "thistickqty"));
            var5.setItemValue(var9, "unitprice", var2.getItemValue(var12[var13], "unitprice"));
            var5.setItemValue(var9, "total_line", var2.getItemValue(var12[var13], "thistickmoney"));
            var5.setItemValue(var9, "sasettledtlid", var2.getItemValue(var12[var13], "sasettledtlid"));
            var5.setItemValue(var9, "invalidflag", "0");
            var5.setItemValue(var9, "salerid", var2.getItemValue(var12[var13], "salerid"));
            var5.setItemValue(var9, "salername", var2.getItemValue(var12[var13], "salername"));
            var5.setItemValue(var9, "salesdeptid", var2.getItemValue(var12[var13], "salesdeptid"));
            var5.setItemValue(var9, "salesdeptname", var2.getItemValue(var12[var13], "salesdeptname"));
            var5.setItemValue(var9, "recsalerid", var4.getUserid());
            var5.setItemValue(var9, "recsalername", var4.getUsername());
            var5.setItemValue(var9, "recsalesdeptid", var4.getDeptid());
            var5.setItemValue(var9, "recsalesdeptname", var4.getDeptname());
            var5.setItemValue(var9, "settype", var2.getItemValue(var12[var13], "settype"));
            var5.setItemValue(var9, "ephedrine", var2.getItemValue(var12[var13], "ephedrine"));
            var5.setItemValue(var9, "invno", var2.getItemValue(var12[var13], "invno"));
            String var11;
            if ("1".equals(var3)) {
               var5.setItemValue(var9, "cdate", NpbusiDBHelper.getSysdate());
               if ((var11 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange")) == null || var11.equals("")) {
                  var11 = "1";
               }

               var5.setItemValue(var9, "exchange", var11);
            } else {
               this.on_itemvaluechange(var9, "total_line", var2.getItemValue(var12[var13], "thistickmoney"));
            }

            var11 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "sarecid");
            var5.setItemValue(var9, "sarecid", var11);
         }
      }

      this.tableChanged();
      if ("1".equals(var3)) {
         var10 = DecimalHelper.add(NpbusiDBHelper.getPreRecmoney(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "sarecid")), var5.sum("total_line").toString(), 2);
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).setItemValue(this.mdemodel.getMasterModel().getRow(), "premoney", var10);
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).on_itemvaluechange(this.mdemodel.getMasterModel().getRow(), "premoney", var10);
      } else {
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).setItemValue(this.mdemodel.getMasterModel().getRow(), "premoney", this.getDBtableModel().sum("total_line").toString());
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).on_itemvaluechange(this.mdemodel.getMasterModel().getRow(), "premoney", var5.sum("total_line").toString());
      }

      if ("1".equals(var3)) {
         this.mdemodel.doSaveSlient();
      }

   }

   protected int on_beforemodify(int var1) {
      this.setFocus("goodsqty");
      if (this.mdemodel.getMasterModel().getRow() >= 0 && this.mdemodel.getMasterModel().getRow() != this.mdemodel.getMasterModel().getRowCount()) {
         if (!this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus").equals("2")) {
            return -1;
         } else {
            return "1".equals(this.getItemValue(this.getRow(), "invalidflag")) ? -1 : super.on_beforemodify(var1);
         }
      } else {
         return -1;
      }
   }

   public void on_doubleclick(int var1, int var2) {
      this.setFocus("goodsqty");
      super.on_doubleclick(var1, var2);
   }

   protected void on_del(int var1) {
      super.on_del(var1);
      ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).setItemValue(this.mdemodel.getMasterModel().getRow(), "premoney", this.getDBtableModel().sum("total_line").toString());
      ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).on_itemvaluechange(this.mdemodel.getMasterModel().getRow(), "premoney", this.getDBtableModel().sum("total_line").toString());
   }

   public void gensarecdtl(CMdeModel var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "recmethod");
      Userruninfo var3 = ClientUserManager.getCurrentUser();
      DBTableModel var4 = this.getDBtableModel();

      String var6;
      for(int var5 = 0; var5 < var1.getMasterModel().getRowCount(); ++var5) {
         if ((var6 = var1.getMasterModel().getItemValue(var5, "selectflag")) != null && "1".equals(var6)) {
            var6 = var1.getMasterModel().getItemValue(var5, "settype");
            DBTableModel var7 = var1.getDetaildbmodel(var5);

            for(int var8 = 0; var8 < var7.getRowCount(); ++var8) {
               String var9;
               if ((var9 = var7.getItemValue(var8, "thistickmoney")) != null && !var9.equals("") && !var9.equals("0") && !var9.equals("0.00")) {
                  int var11 = var4.getRowCount();
                  var4.appendRow();
                  var4.setItemValue(var11, "goodsid", var7.getItemValue(var8, "goodsid"));
                  var4.setItemValue(var11, "goodsname", var7.getItemValue(var8, "goodsname"));
                  var4.setItemValue(var11, "currencyname", var7.getItemValue(var8, "currencyname"));
                  var4.setItemValue(var11, "goodstype", var7.getItemValue(var8, "goodstype"));
                  var4.setItemValue(var11, "goodsunit", var7.getItemValue(var8, "goodsunit"));
                  var4.setItemValue(var11, "prodarea", var7.getItemValue(var8, "prodarea"));
                  var4.setItemValue(var11, "factoryname", var7.getItemValue(var8, "factoryname"));
                  var4.setItemValue(var11, "goodsqty", var7.getItemValue(var8, "thistickqty"));
                  var4.setItemValue(var11, "unitprice", var7.getItemValue(var8, "unitprice"));
                  var4.setItemValue(var11, "total_line", var7.getItemValue(var8, "thistickmoney"));
                  var4.setItemValue(var11, "sasettledtlid", var7.getItemValue(var8, "sasettledtlid"));
                  var4.setItemValue(var11, "invalidflag", "0");
                  var4.setItemValue(var11, "salerid", var7.getItemValue(var8, "salerid"));
                  var4.setItemValue(var11, "salername", var7.getItemValue(var8, "salername"));
                  var4.setItemValue(var11, "salesdeptid", var7.getItemValue(var8, "salesdeptid"));
                  var4.setItemValue(var11, "salesdeptname", var7.getItemValue(var8, "salesdeptname"));
                  var4.setItemValue(var11, "recsalerid", var3.getUserid());
                  var4.setItemValue(var11, "recsalername", var3.getUsername());
                  var4.setItemValue(var11, "recsalesdeptid", var3.getDeptid());
                  var4.setItemValue(var11, "recsalesdeptname", var3.getDeptname());
                  var4.setItemValue(var11, "settype", var6);
                  var4.setItemValue(var11, "ephedrine", var7.getItemValue(var8, "ephedrine"));
                  var4.setItemValue(var11, "invno", var7.getItemValue(var8, "invno"));
                  String var10;
                  if ("1".equals(var2)) {
                     var4.setItemValue(var11, "cdate", NpbusiDBHelper.getSysdate());
                     if ((var10 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange")) == null || var10.equals("")) {
                        var10 = "1";
                     }

                     var4.setItemValue(var11, "exchange", var10);
                  } else {
                     this.on_itemvaluechange(var11, "total_line", var7.getItemValue(var8, "thistickmoney"));
                  }

                  var10 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "sarecid");
                  var4.setItemValue(var11, "sarecid", var10);
               }
            }
         }
      }

      this.tableChanged();
      if ("1".equals(var2)) {
         var6 = DecimalHelper.add(NpbusiDBHelper.getPreRecmoney(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "sarecid")), var4.sum("total_line").toString(), 2);
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).setItemValue(this.mdemodel.getMasterModel().getRow(), "premoney", var6);
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).on_itemvaluechange(this.mdemodel.getMasterModel().getRow(), "premoney", var6);
      } else {
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).setItemValue(this.mdemodel.getMasterModel().getRow(), "premoney", this.getDBtableModel().sum("total_line").toString());
         ((Bms_sa_rec_master)this.mdemodel.getMasterModel()).on_itemvaluechange(this.mdemodel.getMasterModel().getRow(), "premoney", var4.sum("total_line").toString());
      }

      this.mdemodel.getMasterModel().tableChanged(this.mdemodel.getMasterModel().getRow());
      this.mdemodel.getMasterModel().tableChanged();
      if ("1".equals(var2)) {
         this.mdemodel.doSaveSlient();
      }

   }
}
